// Beispiel fr statisches Laden der FLAMUPEX.DLL
// TestUpEx1.exe lsst sich nicht starten, wenn FLAMUPEX.DLL fehlt!

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#define DECLSPEC __declspec( dllimport )
//#pragma link "flamupex.lib" ist Compilerabhngig
#pragma link "flamupex.lib"

#include "flamupex.h"

int HelpTxt() {
  printf("usage for RunfFlam   : TestUpEx1 R param1 param2 .. paramx\n");
  printf("usage for ExecuteFlam: TestUpEx1 E \"param1,param2, .. ,paramx\"\n");
  printf("usage for flamup     : TestUpEx1 F \"param1,param2, .. ,paramx\"\n");
  return -1;
}

int main( int argc, char * argv[] )
{
  int Result;
  if ( argc <=2 ) goto usage;
  switch ( toupper( *argv[1] ) ) {
  case 'R': {
              argc--;
              argv++;
              Result = RunFlam( argc, argv );
              printf("***** RunFlam: %d\n", Result );
              break;
            }
  case 'E': {
              Result = ExecuteFlam( argv[2] );
              printf("***** ExecuteFlam: %d\n", Result );
              break;
            }
  case 'F': {
              void *Id = NULL;
              long Len = strlen( argv[2] );
              flamup( &Id, (long*)&Result, argv[2], &Len );
              printf("***** flamup: %d\n", Result );
              break;
            }
   default: goto usage;
  }
  return Result;
usage:
  return HelpTxt();
}
