// Beispiel fr dynamisches Laden der FLAMUPEX.DLL
// TestUpEx2.exe lsst sich auch starten, wenn FLAMUPEX.DLL fehlt!

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "flamupex.h"

int HelpTxt() {
  printf("usage for RunfFlam   : TestUpEx1 R param1 param2 .. paramx\n");
  printf("usage for ExecuteFlam: TestUpEx1 E \"param1,param2, .. ,paramx\"\n");
  printf("usage for flamup     : TestUpEx1 F \"param1,param2, .. ,paramx\"\n");
  return -1;
}

int main( int argc, char * argv[] )
{
  int Result = -1;
  HMODULE hModule = NULL;
  if ( argc <=2 ) Result = HelpTxt();
  else {
    TFlamUp flamup;
    TExecuteFlam ExecuteFlam;
    TRunFlam RunFlam;
    hModule = LoadLibrary( "flamupex.dll" );
    if ( !hModule ) {
      printf( "LoadLibrary( \"flamupex.dll\" ): ERROR %d\n", GetLastError() );
      return -1;
    }

    flamup = (TFlamUp)GetProcAddress( hModule, "flamup" );
    if ( !flamup ) {
      printf( "GetProcAddress( hModule, \"flamup\" ): ERROR %d\n", GetLastError() );
      goto ende;
    }
    ExecuteFlam = (TExecuteFlam)GetProcAddress( hModule, "ExecuteFlam" );
    if ( !ExecuteFlam ) {
      printf( "GetProcAddress( hModule, \"ExecuteFlam\" ): ERROR %d\n", GetLastError() );
      goto ende;
    }
    RunFlam = (TRunFlam)GetProcAddress( hModule, "RunFlam" );
    if ( !ExecuteFlam ) {
      printf( "GetProcAddress( hModule, \"RunFlam\" ): ERROR %d\n", GetLastError() );
      goto ende;
    }

  switch ( toupper( *argv[1] ) ) {
  case 'R': {
              argc--;
              argv++;
              Result = RunFlam( argc, argv );
              printf("***** RunFlam: %d\n", Result );
              break;
            }
  case 'E': {
              Result = ExecuteFlam( argv[2] );
              printf("***** ExecuteFlam: %d\n", Result );
              break;
            }
  case 'F': {
              void *Id = NULL;
              long Len = strlen( argv[2] );
              flamup( &Id, (long*)&Result, argv[2], &Len );
              printf("***** flamup: %d\n", Result );
              break;
            }
   default: Result = HelpTxt();
  }
}
ende:
FreeLibrary( hModule );
return Result;
}

